
// declaration
var express = require('express');
var app = express()
  , http = require('http').createServer(app)
  , io = require('socket.io').listen(http)
  , routes = require('./routes')
  , user = require('./routes/user')
  , socketio = require('./routes/socketio')
  , news = require('./routes/news')
  , chat = require('./routes/chat')
  , path = require('path');

// configuration
app.configure(function(){
  app.set('port', process.env.PORT || 3000);
  app.set('views', __dirname + '/views');
  app.set('view engine', 'jade');
  app.use(express.favicon());
  //app.use(express.logger('dev'));
  app.use(express.bodyParser());
  app.use(express.methodOverride());
  app.use(app.router);
  app.use(express.static(path.join(__dirname, 'public')));
});
app.configure('development', function(){
  app.use(express.errorHandler());
});

// url route
app.get('/', routes.index);
app.get('/users', user.list);
app.get('/socketio', socketio.io);
app.get('/news', news.news);
app.get('/chat', chat.chat);

// http listen
http.listen(app.get('port'), function(){
  console.log("Express server listening on port " + app.get('port'));
});

// socket on  : bi-direction
var general = io.sockets.on('connection', function(socket) {
    console.log('>>> server connection');

    socket.on('server_1', function(data) {
        if(data != undefined) {
            console.log('>>>>>' + data);
        }

        var msg = 'hi youngsik';
        socket.emit('client_1', msg);
    });
});

// socket.io namespace for multiplexing
var chat = io
    .of('/chat')
    .on('connection', function (socket) {
        console.log('>>> chat server connection');

        socket.on('server_1', function(data) {
            if(data != undefined) {
                console.log('>>>>' + data);
            }

            var gen_msg = 'general connection';
            var chat_msg = 'chating youngsik';
            general.emit('client_1', { that: 'only', message: gen_msg });
            chat.emit('client_1', { everyone: 'in', message: chat_msg });
        });
    });

var news = io
    .of('/news')
    .on('connection', function (socket) {
        console.log('>>> news server connection');

        socket.on('server_1', function(data) {
            if(data != undefined) {
                console.log('>>>>' + data);
            }

            var news_msg = 'news youngsik';
            news.emit('client_1', { everyone: 'in', message: news_msg });
        });
    });

